// gv𑀍삷NX
class CardsManager {
	// gvz
	private int[] cards;

	//  z̒l
	//  000 : W[J[
	//  101`113 : Xy[h1`13
	//  201`213 : n[g1`13
	//  301`313 : _C1`13
	//  401`413 : Nu1`13

	// RXgN^
	public CardsManager()
	{
		// z쐬
		cards = new int[ 13 * 4 + 1 ];

		// 
		organize();
	}


	// gv̐
	public void organize()
	{
		// W[J[i[
		cards[ 0 ] = 0;

		for ( int i = 1; i <= 13; ++ i ) {
			// Xy[hi[(Y:1`13)
			cards[ i ] = 100 + i;

			// _Ci[(Y:14`26)
			cards[ i + 13 ] = 300 + i;

			// Nui[(Y:27`39)
			cards[ i + 26 ] = 400 + i;

			// n[gi[(Y:40`52)
			cards[ i + 39 ] = 200 + i;
		}
	}


	// gṽVbt
	public void shuffle()
	{
		for ( int i = 0; i < cards.length; ++ i ) {
			// 0`(zary̌-1)̗𔭐
			int rnd = (int)( Math.random() * (double)cards.length );

			// cards[ i ]cards[ rnd ]ւ
			int w = cards[ i ];
			cards[ i ] = cards[ rnd ];
			cards[ rnd ] = w;
		}
	}


	// gv̎擾
	public int getCard( int num )
	{
		// numA1`53ԖڈȊȌꍇA-1߂
		if ( ( 1 > num ) || ( 53 < num ) ) return -1;

		// J[h߂
		return cards[ num - 1 ];
	}
}


// C
public class PokerHands {
	// G[
	static final int ERROR           = 0;

	// |[J[̖̒萔`Ă܂B
	// CtbViCXg[gtbVj
	static final int ROYAL_FLUSH     = 1;
	// Xg[gtbV
	static final int STRAIGHT_FLUSH  = 2;
	// tH[J[h
	static final int FOUR_OF_A_KIND  = 3;
	// tnEX
	static final int FULL_HOUSE      = 4;
	// tbV
	static final int FLUSH           = 5;
	// Xg[g
	static final int STRAIGHT        = 6;
	// X[J[h
	static final int THREE_OF_A_KIND = 7;
	// c[yA
	static final int TWO_PAIR        = 8;
	// yA
	static final int ONE_PAIR        = 9;
	// m[yA
	static final int NO_PAIR         = 10;


	// J[hTzœnĖ𔻒肷郁\bh
	static int getPockerHand( int[] cards )
	{
		// znullG[
		if ( null == cards ) return ERROR;

		// ž5łȂ΃G[
		if ( 5 != cards.length ) return ERROR;


		// gṽ}[Ňi[z
		int[] suit = new int[ 4 ];

		// gṽ}[Ň0ij
		for ( int i = 0; i < suit.length; i++ )
			suit[ i ] = 0;


		// gv̔ԍ(1-13)̌i[z
		// number[ 0 ]number[13]̗Ǎi[
		int[] number = new int[ 14 ];

		// gṽ}[Ň0ij
		for ( int i = 0; i < number.length; i++ )
			number[ i ] = 0;

		// T̃J[h̃}[NƔԍ̌i[
		for ( int i = 0; i < cards.length; i++ ) {
			// }[N
			int mark = cards[ i ] / 100;
			// ԍ
			int num = cards[ i ] % 100;

			// mark14͈̔͊Oł΃G[
			if ( ( 1 > mark ) || ( 4 < mark ) ) {
				return ERROR;
			}

			// num113͈̔͊Oł΃G[
			if ( ( 1 > num ) || ( 13 < num ) ) {
				return ERROR;
			}

			// }[ŇɂP𑫂
			++ suit[ mark - 1 ];

			// ԍ̌ɂP𑫂
			++ number[ num - 1 ];
		}
		// number[ 13 ]Ǎ
		number[ 13 ] = number[ 0 ];

		// ԍ̌̍ől擾
		int number_max = 0;
		for ( int i = 0; i < number.length - 1; i++ ) {
			if ( number_max < number[ i ] )
				number_max = number[ i ];
		}

		// 画菈

		// ̍ő傪S̏ꍇAtH[J[hm
		if ( 4 == number_max )
			return FOUR_OF_A_KIND;

		
		// }[Ň̍ől擾
		// T̃J[h}[N̏ꍇAsuit_max=5ƂȂ
		int suit_max = 0;
		for ( int i = 0; i < suit.length; i++ ) {
			if ( suit_max < suit[ i ] )
				suit_max = suit[ i ];
		}

		// Xg[g̔
		boolean isStraight = false;
		int continuous1 = 0;
		int firstnum = 0;
		for ( int i = 0; i < number.length; ++ i ) {
			if ( 1 != number[ i ] ) {
				continuous1 = 0;
				firstnum = 0;
			}
			else {
				++ continuous1;
				// Xg[g̍ŏ̔ԍi[
				if ( 1 == continuous1 )
					firstnum = i + 1;

				// TA
				if ( 5 == continuous1 ) {
					// Xg[g͊m
					isStraight = true;
					break;
				}
			}
		}

		// }[NSēŁAXg[g
		if ( ( 5 == suit_max ) && isStraight ) {
			// Xg[g̐擪̔ԍ10
			if ( 10 == firstnum ) {
				// CtbVm
				return ROYAL_FLUSH;
			}
			// Xg[gtbVm
			return STRAIGHT_FLUSH;
		}

		// ̍ő傪RŁAPyA݂
		if ( 3 == number_max ) {
			for ( int i = 0; i < number.length - 1; ++ i ) {
				if ( 2 == number[ i ] ) {
					// tnEXm
					return FULL_HOUSE;
				}
			}
		}


		// }[NSē
		if ( 5 == suit_max ) {
			// tbVm
			return FLUSH;
		}

		// Xg[g
		if ( isStraight ) {
			// Xg[gm
			return STRAIGHT;
		}

		// ̍ő傪ȐꍇAX[J[hm
		if ( 3 == number_max )
			return THREE_OF_A_KIND;

		// yǍ
		int pair_num = 0;
		for ( int i = 0; i < number.length - 1; ++ i ) {
			if ( 2 == number[ i ] )
				++ pair_num;
		}

		// yAQł
		if ( 2 == pair_num )
			return TWO_PAIR;

		// yAPł
		if ( 1 == pair_num )
			return ONE_PAIR;

		// m[yA
		return NO_PAIR;
	}


	// ԍ𕶎ɕϊ
	static String getStringNumber( int num ) {
		switch ( num ) {
			case 1:
				return "A";
			case 2:
				return "2";
			case 3:
				return "3";
			case 4:
				return "4";
			case 5:
				return "5";
			case 6:
				return "6";
			case 7:
				return "7";
			case 8:
				return "8";
			case 9:
				return "9";
			case 10:
				return "10";
			case 11:
				return "J";
			case 12:
				return "Q";
			case 13:
				return "K";
		}
		return "";
	}


	// C
	public static void main( String[] args ) {
		// gvNX쐬
		CardsManager cards = new CardsManager();

		// ϐ錾
		int[] cards5 = new int[ 5 ];

		// 200񏈗
		int loopcount = 200;
		for ( int j = 0; j < loopcount; ++ j ) {
			// gvVbt
			cards.shuffle();

			// gvォ珇ԂɈĂ
			int card_num = 0;
			for ( int i = 1; i <= 53; ++ i ) {
				// iԖڂ̃J[h擾
				int card = cards.getCard( i );

				// W[J[zɓȂ
				if ( 0 == card ) continue;

				// J[hTɂȂ烋[v𔲂
				cards5[ card_num] = card;
				++ card_num;
				if ( 5 == card_num ) break;
			}


			// J[h\
			for ( int i = 0; i < 5; ++ i ) {
				// }[N
				int mark = cards5[ i ] / 100;
				// ԍ
				int num = cards5[ i ] % 100;

				// ԍ𕶎ɕύX
				String strnum = getStringNumber( num );

				//@\
				switch ( mark ) {
					case 1:
						// Xy[h
						System.out.print( "S" + strnum );
						break;
					case 2:
						// n[g
						System.out.print( "H" + strnum );
						break;
					case 3:
						// _C
						System.out.print( "D" + strnum );
						break;
					case 4:
						// Nu
						System.out.print( "C" + strnum );
						break;
				}
				System.out.print( " " );
			}

			// 𔻒
			int hand = getPockerHand( cards5 );
			switch ( hand ) {
				case ROYAL_FLUSH:
					System.out.println( "CtbV" );	
					break;

				case STRAIGHT_FLUSH:
					System.out.println( "Xg[gtbV" );	
					break;

				case FOUR_OF_A_KIND:
					System.out.println( "tH[J[h" );	
					break;

				case FULL_HOUSE:
					System.out.println( "tnEX" );	
					break;

				case FLUSH:
					System.out.println( "tbV" );	
					break;

				case STRAIGHT:
					System.out.println( "Xg[g" );	
					break;

				case THREE_OF_A_KIND:
					System.out.println( "X[J[h" );	
					break;

				case TWO_PAIR:
					System.out.println( "c[yA" );	
					break;

				case ONE_PAIR:
					System.out.println( "yA" );
					break;

				default:
					System.out.println( "m[yA" );
					break;
			}
		}
	}
}